using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

namespace WK_KLI_LAPS_Service.Controllers.Master.ChapterType
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class ChapterTypeApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private IChapterTypeService _chaptertypeservices;
        public ChapterTypeApiController(IChapterTypeService chaptertypeServices)
        {
            _chaptertypeservices = chaptertypeServices;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _chaptertypeservices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveChapterType")]
        //Code to retrieve active data
        public IActionResult GetActiveChapterType()
        {
            var _list = _chaptertypeservices.GetActiveChapterType();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] chaptertypeModel ochaptertypeModel)
        {

            int retval = 0;
            try
            {
                retval = _chaptertypeservices.Add(ochaptertypeModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPut("Update")]
        public IActionResult Update([FromBody] chaptertypeModel ochaptertypeModel)
        {
            int retval = 0;
            try
            {
                retval = _chaptertypeservices.Edit(ochaptertypeModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] chaptertypeModel ochaptertypeModel)
        {
            int retval = 0;
            try
            {
                retval = _chaptertypeservices.Delete(ochaptertypeModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}